#ifndef _VEHEX_H_
#define _VEHEX_H_

#include <velib/base/base.h>

#define HEX_FLAG_UNKNOWN_ID		0x01
#define HEX_FLAG_READ_ONLY		0x02
#define HEX_FLAG_PARAM_ERROR	0x04

typedef enum { CmdVal_EnterBoot_Reserved  = 0,
			   CmdVal_Ping_Done = 1,
			   CmdVal_Erase_ChecksumError = 2,
			   CmdVal_AppVersion_UnknownCommand = 3,
			   CmdVal_DeviceId_MiscError = 4,
			   CmdVal_Program_PingResponse = 5,
			   CmdVal_Restart_VerifyError = 6,
			   CmdVal_Get_GetResponse = 7,
			   CmdVal_Set_SetResponse = 8,
			   CmdVal_NA_Notify = 0xA} CommandValues;
typedef enum { CmdChar_EnterBoot_Reserved = '0',
			   CmdChar_Ping_Done = '1',
			   CmdChar_Erase_ChecksumError = '2',
			   CmdChar_AppVersion_UnknownCommand = '3',
			   CmdChar_DeviceId_MiscError = '4',
			   CmdChar_Program_PingResponse = '5',
			   CmdChar_Restart_VerifyError = '6',
			   CmdChar_Get_GetResponse = '7',
			   CmdChar_Set_SetResponse = '8',
			   CmdChar_NA_Notify = 'A'} CommandChars;
typedef enum { StateCommand, StateIgnore, StateVeRegId, StateFlags, StateData } HexState;

typedef struct {
	CommandChars response;
	un16 veRegId;
	un8 flags;
	un8 length;
	un8 *data;
} HexMessage;

typedef struct {
	un8 checksum;
	un8 byteCount;
	un8 byte;
	veBool leastNibble;
	HexMessage message;
	HexState rxState;
	un8 txBuf[1 + 1 + 4 + 2 + 2*CFG_VEHEX_TX_DATA_LEN + 2 + 1];
	un8 rxBuf[CFG_VEHEX_RX_DATA_LEN + 1];
} VdHexInstance;

/*
 * API functions
 */
void veHexSendPing(VdHexInstance * instance);
void veHexGetDeviceId(VdHexInstance * instance);
void veHexRestart(VdHexInstance * instance);
void veHexGet(VdHexInstance * instance, un16 id);
void veHexSet(VdHexInstance * instance, un16 id, un8 const * payload, un8 length);

void veHexInit(VdHexInstance * instance);

/* vetext_fh API */
veBool	veHexRxEvent(VdHexInstance * instance, un8 c);

#endif // _VEHEX_H_
