#ifndef _VETEXT_FH_H_
#define _VETEXT_FH_H_

#include <velib/base/types.h>
#include "vetext.h"
#include "vehex.h"

typedef enum
{
	IDLE,
	RECORD_BEGIN,
	RECORD_HEX,
	RECORD_NAME,
	RECORD_VALUE,
	CHECKSUM
} RxState;

// The name of the record that contains the checksum.
#define VE_TEXT_MAX_NAME_LENGTH			8		// "Checksum"
#define VE_TEXT_MAX_VALUE_LENGTH		32		// MPPT solar prod

typedef struct {
	RxState	rxState;
	un8		checksum;
	char	name[VE_TEXT_MAX_NAME_LENGTH+1];		// +1 For zero termination
	char	value[VE_TEXT_MAX_VALUE_LENGTH+1];		// +1 For zero termination
	char *	pName;
	char *	pValue;
	veBool	invalidFrame;
} VdTextFhInstance;

#ifdef __cplusplus
extern "C" {
#endif

void vhInit(VdTextFhInstance * instance);
void vhRxData(VdTextFhInstance * instance, VdTextInstance * textInstance, VdHexInstance * hexInstance, un8 inbyte);

#ifdef __cplusplus
}
#endif
#endif // _VETEXT_FH_H_
