#ifndef VEDIRECT_BMV_H
#define VEDIRECT_BMV_H

#include "veti_common.h"

typedef struct
{
	VeTinyItem deepestDischarge;			/* [h1] DeepestDischarge [Ah] */
	VeTinyItem lastDischarge;				/* [h2] Depth of last discharge [Ah], resetted at synchronisation. */
	VeTinyItem averageDischarge;			/* [h3] AverageDischarge [Ah] */
	VeTinyItem chargeCycles;				/* [h4] Number of dischargers, used for calculation of AverageDischarge.  */
	VeTinyItem fullDischarges;				/* [h5] Number of full discharges, reaching 0.0% */
	VeTinyItem totalAhDrawn;				/* [h6] Cumulative Ampere Hours */
	VeTinyItem minimumVoltage;				/* [h7] Minimum Battery Volts measured */
	VeTinyItem maximumVoltage;				/* [h8] Maximum Battery Volts measured */
	VeTinyItem timeSinceLastFullCharge;		/* [h9] Days since last full charge */
	VeTinyItem automaticSyncs;				/* [h10] number of synchronisatations */
	VeTinyItem lowVoltageAlarms;			/* [h11] The number of low voltage alarms. */
	VeTinyItem highVoltageAlarms;			/* [h12] The number of high voltage alarms */

	VeTinyItem lowStarterVoltageAlarms;		/* [h13] The number of low starter battery voltage alarms. */
	VeTinyItem highStarterVoltageAlarms;	/* [h14] The number of high starter battery voltage alarms */
	VeTinyItem minimumStarterVoltage;		/* [h15] The minimum starter battery voltage. */
	VeTinyItem maximumStarterVoltage;		/* [h16] The maximum starter battery voltage. */

	VeTinyItem chargedEnergy;				/* [h18] The amount of charged energy. */
	VeTinyItem dischargedEnergy;			/* [h19] The amount of discharged energy. */
} BmvHistory;

typedef struct
{
	VeTinyItem hasPower;
	VeTinyItem hasTemperature;
	VeTinyItem hasStarterVoltage;
	VeTinyItem hasMidVoltage;
} BmvSettings;

typedef struct
{
	VeTinyItem voltage;
} BmvAuxiliary;

typedef struct
{
	VeTinyItem	consumedAmphours;
	VeTinyItem	stateOfCharge;
	VeTinyItem	timeToGo;
	VeTinyItem	temperature;
} BmvState;

typedef struct
{
	BmvState		state;
	BmvAuxiliary	auxiliary;
#if CFG_VEDIRECT_WITH_HISTORY
	BmvHistory		history;
#endif
	//BmvSettings	settings;
} VeBmv;

#endif // VEDIRECT_BMV_H
