#ifndef ITEMS_GENERAL_H
#define ITEMS_GENERAL_H

#include <velib/types/ve_item.h>
#include <velib/types/ve_item_def.h>

typedef struct
{
	VeItem voltage;
	VeItem current;
	VeItem power;
	VeItem temperature;
	VeItem midVoltage;
	VeItem midVoltageDev;
} DcStatus;

typedef struct
{
	VeItem voltage;
	VeItem current;
	VeItem power;
} AcStatus;

typedef struct
{
	VeItem capabilities1;
	VeItem hasLoadOutput;
	VeItem hasRotaryEncoder;
	VeItem hasHistorySupport;
	VeItem hasBatterySafeMode;
	VeItem hasAdaptiveMode;
	VeItem hasManualEqualise;
	VeItem hasAutomaticEqualise;
	VeItem hasStorageMode;
	VeItem hasRemoteOnOff;
	VeItem hasSolarTimer;
	VeItem hasAltTxFunction;
	VeItem hasUserLoadSwitch;
	VeItem hasLoadCurrent;
	VeItem hasPanelCurrent;
	VeItem hasBmsSupport;
	VeItem hasHub1Support;
	VeItem hasParallelSupport;
	VeItem hasAlarmRelay1;
	VeItem hasAltRxFunction;
	VeItem hasVirtualLoadOutput;
	VeItem hasVirtualRelay;
} Capabilities;

#endif // ITEMS_GENERAL_H

