#ifndef VEDIRECT_INVERTER_ITEMS_H
#define VEDIRECT_INVERTER_ITEMS_H

#include <velib/types/ve_item.h>

#include "vedirect_general_items.h"

typedef struct
{
#ifdef ITEM_TREE
	VeItem lowVoltage;
	VeItem highVoltage;
	VeItem lowTemperature;
	VeItem highTemperature;
	VeItem overload;
	VeItem dcRipple;
	VeItem lowVoltageAcOut;
	VeItem highVoltageAcOut;
#endif
} InverterAlarmItems;

typedef struct
{
	VeItem someSetting;
} InverterSettings;

typedef struct VeInverterS
{
	DcStatus			dcBatteryStatus;
	AcStatus			acOutStatus;
	VeItem				deviceMode;
	VeItem				deviceState;
	InverterAlarmItems	alarms;
	VeItem				alarmReason;
	VeItem				warningReason;
	InverterSettings	settings;
	un16				warnFlags;
	un16				alarmFlags;
} VeInverter;

#endif // VEDIRECT_INVERTER_ITEMS_H
