#include <string.h>

#include <velib/base/base.h>
#include <velib/platform/plt.h>
#include <velib/platform/serial.h>
#include <velib/utils/ve_logger.h>

#include "serial_hal.h"

static VeSerialPort veSerialPort;

veBool serialConnect(veSerialRxCb *rxCallback, veSerialEventCb *eventCallback)
{
	veSerialPort.baudrate = 19200;
	veSerialPort.dev = strdup(pltGetSerialDevice());
	veSerialPort.eventCallback = eventCallback;
	veSerialPort.rxCallback = rxCallback;
	veSerialPort.intLevel = 0;

	return veSerialOpen(&veSerialPort, NULL);
}

veBool serialSendBuf(un8 const *buff, un8 buflen)
{
	return veSerialPutBuf(&veSerialPort, buff, buflen);
}

VeVariant *serialDeviceInstance(VeVariant *var)
{
	return veSerialGetDeviceNumber(&veSerialPort, var);
}
