#include "vedirect_formatters.h"

#include <velib/base/ve_string.h>

size_t versionFmt(VeVariant *var, void const *ctx, char* buf, size_t len)
{
	VE_UNUSED(ctx);

	if (!veVariantIsValid(var))
		return ve_snprintf(buf, len, "%s", "---");

	if (var->value.UN32 & 0x00FF0000) {
		return ve_snprintf(buf, len, "v%X.%02X.%02X",
				(var->value.UN32 >> 16) & 255, (var->value.UN32 >> 8) & 255, var->value.UN32 & 255);
	}
	return ve_snprintf(buf, len, "v%X.%02X", (var->value.UN32 >> 8) & 255, var->value.UN32 & 255);
}

size_t pidFmt(VeVariant *var, void const *ctx, char* buf, size_t len)
{
	VE_UNUSED(ctx);

	if (!veVariantIsValid(var))
		return ve_snprintf(buf, len, "%s", "---");
	return ve_snprintf(buf, len, "0x%X", var->value.UN32);
}
